<template>
  <nav class="blog-navbar">
    <div class="container navbar-container">
      <a class="navbar-logo" href="/" aria-label="Home">
        <blog-fa-icon icon="user-circle" />
      </a>
      <div class="navbar-nav-scroll">
        <ul class="nav navbar-nav">
          <li
            v-for="(nav, index) in navs"
            :key="index"
            class="nav-item"
          >
            <a
              class="nav-link"
              :class="{ active: index === 0 }"
              :href="nav.href"
              :aria-label="nav.label"
              v-on:click.prevent="onNavClick"
              :ref="'nav-link'"
            >
              {{ nav.label }}
            </a>
          </li>
        </ul>
      </div>
    </div>
  </nav>
</template>

<script>
export default {
  data () {
    return {
      navs: [
        { label: 'Home', href: '#home' },
        { label: 'Showcases', href: '#showcases' },
        { label: 'Blog', href: '#blog' },
        { label: 'Hire me?', href: '#hireme' }
      ]
    }
  },

  computed: {
    sections () {
      const sections = []

      this.navs.forEach(nav => {
        var id = nav.href.replace('#', '')
        var elem = document.getElementById(id)

        if (elem) sections.push([id, elem.offsetTop])
      })

      return sections
    }
  },

  mounted () {
    window.addEventListener('scroll', this.onScroll)
  },

  beforeDestroy () {
    window.removeEventListener('scroll', this.onScroll)
  },

  methods: {
    onScroll () {
      // Shrink navbar.
      if (window.scrollY > 60) this.$el.classList.add('is-shrink')
      else this.$el.classList.remove('is-shrink')

      // Scroll Spy.
      const section = this.sections.filter(item => window.scrollY >= item[1] - 120).pop() || this.sections[0]

      if (section) {
        this.$refs['nav-link'].forEach(node => {
          if (node.classList.contains('active')) node.classList.remove('active')
          if (node.hash === `#${section[0]}`) node.classList.add('active')
        })
      }
    },

    onNavClick (e) {
      var id = e.target.hash.replace('#', '')
      var elem = document.getElementById(id)
      var offset = id === 'home' ? -120 : -76

      if (elem) Velocity(elem, 'scroll', { offset })
    }
  }
}
</script>

<style lang="scss">
.blog-navbar {
  position: fixed;
  display: flex;
  align-items: center;
  top: 0;
  width: 100%;
  font-family: $navbar-font-family;
  background-color: $navbar-bg;
  padding: $navbar-padding-y $navbar-padding-x;
  transition: height .3s;
  z-index: 1;

  &.is-shrink {
    box-shadow: $navbar-box-shadow;
  }

  @media (min-width: map-get($grid-breakpoints, 'md')) {
    height: $navbar-height * 2;

    &.is-shrink {
      height: $navbar-height;
    }
  }

  > .navbar-container {
    display: flex;
    flex-flow: row nowrap;
  }

  .navbar-logo {
    display: inline-block;
    font-size: $navbar-logo-font-size;
    line-height: $navbar-logo-line-height;
  }

  .navbar-nav-scroll {
    position: relative;
    margin-left: auto;
    overflow: hidden;

    .navbar-nav::-webkit-scrollbar {
      display: none;
    }
  }

  .navbar-nav {
    flex-flow: nowrap;
    overflow-x: scroll;

    .nav-link {
      height: 40px;

      @media (max-width: map-get($grid-breakpoints, 'md') - 1) {
        padding-left: $navbar-nav-link-padding-x;
        padding-right: $navbar-nav-link-padding-x;
      }

      &.active::after {
        display: block;
        content: '';
        border-top: $navbar-nav-link-border-width solid $primary;
      }
    }
  }
}
</style>
